com.fasterxml.jackson.databind.ser.std

## Class CollectionSerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<T>
    - - com.fasterxml.jackson.databind.ser.ContainerSerializer<T>
      - - com.fasterxml.jackson.databind.ser.std.AsArraySerializerBase<Collection<?>>
        - - com.fasterxml.jackson.databind.ser.std.CollectionSerializer

All Implemented Interfaces:
  JsonFormatVisitable, SchemaAware, ContextualSerializer, Serializable

    public class CollectionSerializer
    extends AsArraySerializerBase<Collection<?>>

Fallback serializer for cases where Collection is not known to be of type for which more specializer serializer exists (such as index-accessible List). If so, we will just construct an `Iterator` to iterate over elements.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

`JsonSerializer.None`

### Field Summary

### Fields inherited from class com.fasterxml.jackson.databind.ser.std.AsArraySerializerBase

`_dynamicSerializers, _elementSerializer, _elementType, _property, _staticTyping, _unwrapSingle, _valueTypeSerializer`

### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`_handledType`

### Constructor Summary

Constructors
Constructor and Description
`CollectionSerializer(CollectionSerializer src, BeanProperty property, TypeSerializer vts, JsonSerializer<?> valueSerializer, Boolean unwrapSingle)`
`CollectionSerializer(JavaType elemType, boolean staticTyping, TypeSerializer vts, BeanProperty property, JsonSerializer<Object> valueSerializer)` Deprecated. since 2.6
`CollectionSerializer(JavaType elemType, boolean staticTyping, TypeSerializer vts, JsonSerializer<Object> valueSerializer)`

### Method Summary

Methods
`ContainerSerializer<?>` `_withValueTypeSerializer(TypeSerializer vts)` Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.
`boolean` `hasSingleElement(Collection<?> value)` Method called to determine if the given value (of type handled by this serializer) contains exactly one element.
`boolean` `isEmpty(SerializerProvider prov, Collection<?> value)` Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).
`void` `serialize(Collection<?> value, JsonGenerator g, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
`void` `serializeContents(Collection<?> value, JsonGenerator g, SerializerProvider provider)`
`void` `serializeContentsUsing(Collection<?> value, JsonGenerator g, SerializerProvider provider, JsonSerializer<Object> ser)`
`CollectionSerializer` `withResolved(BeanProperty property, TypeSerializer vts, JsonSerializer<?> elementSerializer, Boolean unwrapSingle)`

### Methods inherited from class com.fasterxml.jackson.databind.ser.std.AsArraySerializerBase

`_findAndAddDynamic, _findAndAddDynamic, acceptJsonFormatVisitor, createContextual, getContentSerializer, getContentType, getSchema, serializeWithType, withResolved`

### Methods inherited from class com.fasterxml.jackson.databind.ser.ContainerSerializer

`hasContentTypeAnnotation, withValueTypeSerializer`

### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`_neitherNull, _nonEmpty, createSchemaNode, createSchemaNode, findAnnotatedContentSerializer, findContextualConvertingSerializer, findConvertingContentSerializer, findFormatFeature, findFormatOverrides, findIncludeOverrides, findPropertyFilter, getSchema, handledType, isDefaultSerializer, visitArrayFormat, visitArrayFormat, visitFloatFormat, visitIntFormat, visitIntFormat, visitStringFormat, visitStringFormat, wrapAndThrow, wrapAndThrow`

### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

`getDelegatee, isEmpty, isUnwrappingSerializer, properties, replaceDelegatee, unwrappingSerializer, usesObjectId, withFilterId`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### CollectionSerializer

    public CollectionSerializer(JavaType elemType,
                        boolean staticTyping,
                        TypeSerializer vts,
                        JsonSerializer<Object> valueSerializer)

Since:
  2.6

#### CollectionSerializer

    @Deprecated
    public CollectionSerializer(JavaType elemType,
                                   boolean staticTyping,
                                   TypeSerializer vts,
                                   BeanProperty property,
                                   JsonSerializer<Object> valueSerializer)

Deprecated. since 2.6

#### CollectionSerializer

    public CollectionSerializer(CollectionSerializer src,
                        BeanProperty property,
                        TypeSerializer vts,
                        JsonSerializer<?> valueSerializer,
                        Boolean unwrapSingle)

### Method Detail

#### _withValueTypeSerializer

    public ContainerSerializer<?> _withValueTypeSerializer(TypeSerializer vts)

Description copied from class: `ContainerSerializer`
Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.

Specified by:
  `_withValueTypeSerializer` in class `ContainerSerializer<Collection<?>>`

#### withResolved

    public CollectionSerializer withResolved(BeanProperty property,
                                    TypeSerializer vts,
                                    JsonSerializer<?> elementSerializer,
                                    Boolean unwrapSingle)

Specified by:
  `withResolved` in class `AsArraySerializerBase<Collection<?>>`

#### isEmpty

    public boolean isEmpty(SerializerProvider prov,
                  Collection<?> value)

Description copied from class: `JsonSerializer`
Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

Default implementation will consider only null values to be empty.

NOTE: replaces `JsonSerializer.isEmpty(Object)`, which was deprecated in 2.5

Overrides:
  `isEmpty` in class `JsonSerializer<Collection<?>>`

#### hasSingleElement

    public boolean hasSingleElement(Collection<?> value)

Description copied from class: `ContainerSerializer`
Method called to determine if the given value (of type handled by this serializer) contains exactly one element.

Note: although it might seem sensible to instead define something like "getElementCount()" method, this would not work well for containers that do not keep track of size (like linked lists may not).

Note, too, that as of now (2.9) this method is only called by serializer itself; and specifically is not used for non-array/collection types like `Map` or `Map.Entry` instances.

Specified by:
  `hasSingleElement` in class `ContainerSerializer<Collection<?>>`

#### serialize

    public final void serialize(Collection<?> value,
                 JsonGenerator g,
                 SerializerProvider provider)
                         throws IOException

Description copied from class: `JsonSerializer`
Method that can be called to ask implementation to serialize values of type this serializer handles.

Overrides:
  `serialize` in class `AsArraySerializerBase<Collection<?>>`
Parameters:
  `value` - Value to serialize; can not be null.
  `g` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
Throws:
  `IOException`

#### serializeContents

    public void serializeContents(Collection<?> value,
                         JsonGenerator g,
                         SerializerProvider provider)
                           throws IOException

Specified by:
  `serializeContents` in class `AsArraySerializerBase<Collection<?>>`
Throws:
  `IOException`

#### serializeContentsUsing

    public void serializeContentsUsing(Collection<?> value,
                              JsonGenerator g,
                              SerializerProvider provider,
                              JsonSerializer<Object> ser)
                                throws IOException

Throws:
  `IOException`